###############################
# Setup
###############################

###############################
# Include the template scripts
###############################

variables:
  PROJECT: ${MODULE}-test
  DEPENDENCIES: ${MODULE}
  VERSION: "1.0"
  MAINTAINER: "dune-archiso@gitlab.com"
  DUNE_VERSION: 2.9.0.2

include:
  - remote: "https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/module.repo.yaml"
  - remote: "https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/build.yml"
  - remote: "https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/load.yml"
  - remote: "https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/pages.yml"

###############################
# Build from local PKGBUILD
###############################

build_dune-fem:
  extends: .build_aur_template
  tags: [saas-linux-large-amd64]
  stage: .pre
  variables:
    ISARCH4EDU: "true"
    ISAUR: "false"
    MODULE: "dune-fem"
    ISDUNEOPTS: "true"
  before_script:
    - echo -e '\n[dune-archiso-repository-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-archiso-repository-core/$arch\n[dune-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-core/$arch\n[dune-staging]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-staging/$arch\n[dune-extensions]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-extensions/$arch\n' | sudo tee -a /etc/pacman.conf
  after_script:
    - curl -s https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/module_test.sh | bash -e -x

###############################
# Build from local PKGBUILD
###############################

# build_dune-fem-howto:
#   extends: .build_aur_template
#   tags: [saas-linux-large-amd64]
#   stage: .pre
#   variables:
#     ISARCH4EDU: "true"
#     ISAUR: "false"
#     MODULE: "dune-fem-howto"
#     ISDUNEOPTS: "true"
#     ISDEPENDS: "true"
#     DEPENDENCIES_PACKAGE: "dune-fem-${DUNE_VERSION}-*.pkg.tar.zst"
#   before_script:
#     - echo -e '\n[dune-archiso-repository-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-archiso-repository-core/$arch\n[dune-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-core/$arch\n[dune-staging]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-staging/$arch\n[dune-extensions]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-extensions/$arch\n' | sudo tee -a /etc/pacman.conf
#   after_script:
#     - curl -s https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/module_test.sh | bash -e -x
#   needs: ["build_dune-fem"]

###############################
# Build from local PKGBUILD
###############################

build_dune-vem:
  extends: .build_aur_template
  tags: [saas-linux-large-amd64]
  stage: .pre
  variables:
    ISARCH4EDU: "true"
    ISAUR: "false"
    MODULE: "dune-vem"
    ISDEPENDS: "true"
    DEPENDENCIES_PACKAGE: "dune-fem-${DUNE_VERSION}-*.pkg.tar.zst"
  before_script:
    - echo -e '\n[dune-archiso-repository-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-archiso-repository-core/$arch\n[dune-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-core/$arch\n[dune-staging]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-staging/$arch\n[dune-extensions]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-extensions/$arch\n' | sudo tee -a /etc/pacman.conf
  after_script:
    - curl -s https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/module_test.sh | bash -e -x
  needs: ["build_dune-fem"]

###############################
# Build from local PKGBUILD
###############################

build_dune-fem-dg:
  extends: .build_aur_template
  tags: [saas-linux-large-amd64]
  stage: .pre
  variables:
    ISARCH4EDU: "true"
    ISAUR: "false"
    MODULE: "dune-fem-dg"
    ISDEPENDS: "true"
    DEPENDENCIES_PACKAGE: "dune-fem-${DUNE_VERSION}-*.pkg.tar.zst"
  before_script:
    - echo -e '\n[dune-archiso-repository-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-archiso-repository-core/$arch\n[dune-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-core/$arch\n[dune-staging]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-staging/$arch\n[dune-extensions]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-extensions/$arch\n' | sudo tee -a /etc/pacman.conf
  after_script:
    - curl -s https://gitlab.com/dune-archiso/dune-archiso.gitlab.io/-/raw/main/templates/module_test.sh | bash -e -x
  needs: ["build_dune-fem"]

###############################
# Build from local PKGBUILD
###############################

build_dune-fem-module:
  extends: .build_aur_template
  tags: [saas-linux-large-amd64]
  stage: meta
  variables:
    ISARCH4EDU: "true"
    ISAUR: "false"
    MODULE: "dune-fem-module"
    ISDEPENDS: "true"
    DEPENDENCIES_PACKAGE: "dune-fem-${DUNE_VERSION}-*.pkg.tar.zst dune-fem-dg-${DUNE_VERSION}-*.pkg.tar.zst dune-vem-${DUNE_VERSION}-*.pkg.tar.zst" # dune-fem-howto-${DUNE_VERSION}-*.pkg.tar.zst
  before_script:
    - echo -e '\n[dune-archiso-repository-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-archiso-repository-core/$arch\n[dune-core]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-core/$arch\n[dune-staging]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-staging/$arch\n[dune-extensions]\nSigLevel = Required DatabaseOptional\nServer = https://dune-archiso.gitlab.io/repository/dune-extensions/$arch\n' | sudo tee -a /etc/pacman.conf
  needs: [
      "build_dune-fem",
      # "build_dune-fem-howto",
      "build_dune-vem",
      "build_dune-fem-dg",
    ]

###############################
# Create custom repository
###############################

load_repository_dune_fem_modules:
  extends: .load_repository_template
  tags: [saas-linux-large-amd64]
  stage: load_repository
  variables:
    GIT_STRATEGY: none
  dependencies: [
      "build_dune-fem",
      # "build_dune-fem-howto",
      "build_dune-vem",
      "build_dune-fem-dg",
      "build_dune-fem-module",
    ]

###############################
# Upload to GitLab repo (pages)
###############################

pages:
  extends: .pages_template
  tags: [saas-linux-large-amd64]
  stage: deploy
  variables:
    TARGET_FOLDER: "x86_64"
  needs: ["load_repository_dune_fem_modules"]
